

/*

This is the code used to estimate the expected ability and study return variables, along with the R^2 from the student-specific regressions in the year 5 (2018-19) cohort. 

This varaibles are already included in the main analysis file that the code uses below. But the code that constructed these varaibles is provided  here. 


*/



**Set directories. Select the directory where the analysis data is located
global YOUR_PATH_HERE " "

*Analysis Data File Directory:
global input_path "${YOUR_PATH_HERE}\3 replication package\data\input\"


*Bring in the analysis data
use "${input_path}year5_April2022FlwUp_anlaysis_file_anonymized1.dta", clear 


reshape long grade_if_xstudyhrs exp_grade_if_xstudyhrs, i(anonymized_student_id) j(hours_studying)

egen id_for_reg = group(anonymized_student_id)

gen expected_study_ability0 = . 
gen expected_study_ability1 = . 
gen expected_study_return0 = . 
gen expected_study_return1 = . 
gen r2_0 = . 
gen r2_1 = . 

 
gen hours_studying_squared = hours_studying^2

gen expected_study_abilityq0 = . 
gen expected_study_abilityq1 = . 
gen expected_study_return_q1_0 = . 
gen expected_study_return_q1_1 = .
gen expected_study_return_q2_0 = . 
gen expected_study_return_q2_1 = .
gen r2q_0 = . 
gen r2q_1 = . 

set more off
sum id_for_reg
scalar max = r(max)

forvalues i = 1/`=scalar(max)'{
di "obs. no. is `i'"
qui cap reg grade_if_xstudyhrs hours_studying if id_for_reg==`i'
qui cap replace expected_study_ability0 = _b[_cons] if id_for_reg==`i'
qui cap replace expected_study_return0 = _b[hours_studying] if id_for_reg==`i'
qui cap replace r2_0 = e(r2) if id_for_reg==`i'

qui cap reg exp_grade_if_xstudyhrs hours_studying if id_for_reg==`i'
qui cap replace expected_study_ability1 = _b[_cons] if id_for_reg==`i'
qui cap replace expected_study_return1 = _b[hours_studying] if id_for_reg==`i'
qui cap replace r2_1 = e(r2) if id_for_reg==`i'




qui cap reg grade_if_xstudyhrs hours_studying hours_studying_squared if id_for_reg==`i'
qui cap replace expected_study_abilityq0 = _b[_cons] if id_for_reg==`i'
qui cap replace expected_study_return_q1_0 = _b[hours_studying] if id_for_reg==`i'
qui cap replace expected_study_return_q2_0 = _b[hours_studying_squared] if id_for_reg==`i'
qui cap replace r2q_0 = e(r2) if id_for_reg==`i'


qui cap reg exp_grade_if_xstudyhrs hours_studying hours_studying_squared if id_for_reg==`i'
qui cap replace expected_study_abilityq1 = _b[_cons] if id_for_reg==`i'
qui cap replace expected_study_return_q1_1 = _b[hours_studying] if id_for_reg==`i'
qui cap replace expected_study_return_q2_1 = _b[hours_studying_squared] if id_for_reg==`i'
qui cap replace r2q_1 = e(r2) if id_for_reg==`i'

}

drop id_for_reg
drop hours_studying_squared
reshape wide grade_if_xstudyhrs exp_grade_if_xstudyhrs, i(anonymized_student_id) j(hours_studying)

gen expected_ability0_facevalue = grade_if_xstudyhrs0
gen expected_ability1_facevalue = exp_grade_if_xstudyhrs0


