

/*

This is the code used to estimate the expected ability and study return variables, along with the R^2 from the student-specific regressions in the year 6 (2019-20) cohort. 

This varaibles are already included in the main analysis file that the code uses below. But the code that constructed these varaibles is provided  here. 


*/


**Set directories. Select the directory where the analysis data is located
global YOUR_PATH_HERE " "

*Analysis Data File Directory:
global input_path "${YOUR_PATH_HERE}\3 replication package\data\input\"

*Bring in the analysis data
use   "${input_path}year6_anlaysis_file_anonymized1.dta", clear

rename expected_grade_ifstdy_0hrs0 expected_grade_ifstdy0_hrs0
rename expected_grade_ifstdy_5hrs0 expected_grade_ifstdy0_hrs5
rename expected_grade_ifstdy_10hrs0 expected_grade_ifstdy0_hrs10
rename expected_grade_ifstdy_15hrs0 expected_grade_ifstdy0_hrs15
rename expected_grade_ifstdy_20hrs0 expected_grade_ifstdy0_hrs20
rename expected_grade_ifstdy_25hrs0 expected_grade_ifstdy0_hrs25
rename expected_grade_ifstdy_30hrs0 expected_grade_ifstdy0_hrs30
rename expected_grade_ifstdy_35hrs0 expected_grade_ifstdy0_hrs35
rename expected_grade_ifstdy_40hrs0 expected_grade_ifstdy0_hrs40
rename expected_grade_ifstdy_45hrs0 expected_grade_ifstdy0_hrs45
rename expected_grade_ifstdy_50hrs0 expected_grade_ifstdy0_hrs50

rename expected_grade_ifstdy_0hrs1 expected_grade_ifstdy1_hrs0
rename expected_grade_ifstdy_5hrs1 expected_grade_ifstdy1_hrs5
rename expected_grade_ifstdy_10hrs1 expected_grade_ifstdy1_hrs10
rename expected_grade_ifstdy_15hrs1 expected_grade_ifstdy1_hrs15
rename expected_grade_ifstdy_20hrs1 expected_grade_ifstdy1_hrs20
rename expected_grade_ifstdy_25hrs1 expected_grade_ifstdy1_hrs25
rename expected_grade_ifstdy_30hrs1 expected_grade_ifstdy1_hrs30
rename expected_grade_ifstdy_35hrs1 expected_grade_ifstdy1_hrs35
rename expected_grade_ifstdy_40hrs1 expected_grade_ifstdy1_hrs40
rename expected_grade_ifstdy_45hrs1 expected_grade_ifstdy1_hrs45
rename expected_grade_ifstdy_50hrs1 expected_grade_ifstdy1_hrs50


reshape long expected_grade_ifstdy0_hrs expected_grade_ifstdy1_hrs, i(anonymized_student_id) j(hours_studying)

keep anonymized_student_id expected_grade_ifstdy0_hrs expected_grade_ifstdy1_hrs hours_studying

egen id_for_reg = group(anonymized_student_id)

gen expected_study_ability0 = . 
gen expected_study_ability1 = . 
gen expected_study_return0 = . 
gen expected_study_return1 = . 
gen r2_0 = . 
gen r2_1 = . 


gen hours_studying_squared = hours_studying^2

gen expected_study_abilityq0 = . 
gen expected_study_abilityq1 = . 
gen expected_study_return_q1_0 = . 
gen expected_study_return_q1_1 = .
gen expected_study_return_q2_0 = . 
gen expected_study_return_q2_1 = .
gen r2q_0 = . 
gen r2q_1 = . 

set more off
sum id_for_reg
scalar max = r(max)

forvalues i = 1/`=scalar(max)'{
di "obs. no. is `i'"
qui cap reg expected_grade_ifstdy0_hrs hours_studying if id_for_reg==`i'
qui cap replace expected_study_ability0 = _b[_cons] if id_for_reg==`i'
qui cap replace expected_study_return0 = _b[hours_studying] if id_for_reg==`i'
qui cap replace r2_0 = e(r2) if id_for_reg==`i'


qui cap reg expected_grade_ifstdy1_hrs  hours_studying if id_for_reg==`i'
qui cap replace expected_study_ability1 = _b[_cons] if id_for_reg==`i'
qui cap replace expected_study_return1 = _b[hours_studying] if id_for_reg==`i'
qui cap replace r2_1 = e(r2) if id_for_reg==`i'




qui cap reg expected_grade_ifstdy0_hrs hours_studying hours_studying_squared if id_for_reg==`i'
qui cap replace expected_study_abilityq0 = _b[_cons] if id_for_reg==`i'
qui cap replace expected_study_return_q1_0 = _b[hours_studying] if id_for_reg==`i'
qui cap replace expected_study_return_q2_0 = _b[hours_studying_squared] if id_for_reg==`i'
qui cap replace r2q_0 = e(r2) if id_for_reg==`i'


qui cap reg expected_grade_ifstdy1_hrs  hours_studying hours_studying_squared if id_for_reg==`i'
qui cap replace expected_study_abilityq1 = _b[_cons] if id_for_reg==`i'
qui cap replace expected_study_return_q1_1 = _b[hours_studying] if id_for_reg==`i'
qui cap replace expected_study_return_q2_1 = _b[hours_studying_squared] if id_for_reg==`i'
qui cap replace r2q_1 = e(r2) if id_for_reg==`i'

}

drop id_for_reg
drop hours_studying_squared
reshape wide expected_grade_ifstdy0_hrs expected_grade_ifstdy1_hrs, i(anonymized_student_id) j(hours_studying)

gen expected_ability0_facevalue = expected_grade_ifstdy0_hrs0 
gen expected_ability1_facevalue = expected_grade_ifstdy1_hrs0

keep id expected_study_ability1 expected_study_return0 expected_study_return1 expected_study_abilityq0 expected_study_abilityq1 expected_study_return_q1_0 expected_study_return_q1_1 expected_study_return_q2_0 expected_study_return_q2_1 expected_ability0_facevalue expected_ability1_facevalue expected_study_ability0 r2*


